﻿Public Class Main
    Dim ProcedureNumber As Integer
    Dim ForumPostTime As Integer
    Private Sub btnStart_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStart.Click
        On Error GoTo StopIt

        tmrForumPostTime.Enabled = True
        txtForumSite.Enabled = False
        btnNavigate.Enabled = False
        btnStop.Enabled = True
        btnStart.Enabled = False


        For Each Item In lstForumBoardLinks.Items
            If btnStop.Enabled = True Then
                wbForum.Navigate(Item)
                lblStatus.Text = "Loading Page"
                PostFullMessage()
            End If
        Next
        AddLogInfo("--------------Forum Poster successfully posted and stopped at procedure Nr: " & ProcedureNumber & ".--------------")


StopIt:
        AddLogInfo("--------------Problem in posting procedure Nr: " & ProcedureNumber & ", stopping.--------------")
    End Sub
    Private Sub wbForum_DocumentCompleted(ByVal sender As Object, ByVal e As System.Windows.Forms.WebBrowserDocumentCompletedEventArgs) Handles wbForum.DocumentCompleted
        lblStatus.Text = "Page Loaded"
    End Sub
    Private Sub btnStop_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnStop.Click
        txtForumSite.Enabled = True
        btnNavigate.Enabled = True
        btnStart.Enabled = True
        tmrForumPostTime.Enabled = False
        AddLogInfo("--------------Forum Poster stopped procedure Nr: " & ProcedureNumber & ".--------------")
        btnStop.Enabled = False

    End Sub

    Private Sub btnNavigate_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnNavigate.Click
        wbForum.Navigate(txtForumSite.Text)
        lblStatus.Text = "Loading Page"
    End Sub

    Private Sub Main_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        wbForum.Dispose()
    End Sub

    Private Sub Main_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        wbForum.Navigate("")
    End Sub
    Public Sub NavigateBoard()
        If btnStop.Enabled = True Then
            ProcedureNumber += 1
            AddLogInfo("--------------Starting posting procedure Nr: " & ProcedureNumber & ".--------------")
            Do While lblStatus.Text = "Loading Page"
                If lblStatus.Text = "Page Loaded" Then Exit Do
                Application.DoEvents()
            Loop
        End If
    End Sub
    Public Sub NavigateMakeThread()
        If btnStop.Enabled = True Then
            For Each Unit As HtmlElement In wbForum.Document.All
                'Navigating to thread creating page
                If Unit.GetAttribute("alt") = "Post New Thread" Then
                    lblStatus.Text = "Loading Page"
                    Unit.InvokeMember("click")
                End If
            Next
            Do While lblStatus.Text = "Loading Page"
                If lblStatus.Text = "Page Loaded" Then Exit Do
                Application.DoEvents()
            Loop
        End If
    End Sub
    Public Sub CreateThread()
        If btnStop.Enabled = True Then
            Try
                For Each Unit As HtmlElement In wbForum.Document.All

                    'Title set
                    If Unit.GetAttribute("name") = "subject" Or Unit.GetAttribute("id") = "vB_Editor_001_textareaThen" Then
                        Unit.SetAttribute("value", txtPostTitle.Text)
                        AddLogInfo("Thread title set!")
                    End If
                    'Body set
                    If Unit.GetAttribute("name") = "message" Then
                        Unit.SetAttribute("value", txtPostBody.Text)
                        AddLogInfo("Thread body set!")
                    End If
                    'Icon set
                    If rbtnSmile.Checked = True Then
                        If Unit.GetAttribute("value") = "7" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Smile")
                        End If
                    End If
                    If rbtnTalking.Checked = True Then
                        If Unit.GetAttribute("value") = "10" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Talking")
                        End If
                    End If
                    If rbtnWink.Checked = True Then
                        If Unit.GetAttribute("value") = "12" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Wink")
                        End If
                    End If
                    If rbtnRedFace.Checked = True Then
                        If Unit.GetAttribute("value") = "11 Then" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Red face")
                        End If
                    End If
                    If rbtnCool.Checked = True Then
                        If Unit.GetAttribute("value") = "6" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Cool")
                        End If
                    End If
                    If rbtnUnhappy.Checked = True Then
                        If Unit.GetAttribute("value") = "9" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Unhappy")
                        End If
                    End If
                    If rbtnAngry.Checked = True Then
                        If Unit.GetAttribute("value") = "8" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Angry")
                        End If
                    End If
                    If rbtnThumbsUp.Checked = True Then
                        If Unit.GetAttribute("value") = "14" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Thumbs up")
                        End If
                    End If
                    If rbtnThumbsDown.Checked = True Then
                        If Unit.GetAttribute("value") = "13" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Thumbs down")
                        End If
                    End If
                    If rbtnExclamation.Checked = True Then
                        If Unit.GetAttribute("value") = "4" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Exclamation")
                        End If
                    End If
                    If rbtnLightbulb.Checked = True Then
                        If Unit.GetAttribute("value") = "3" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Lightbulb")
                        End If
                    End If
                    If rbtnQuestion.Checked = True Then
                        If Unit.GetAttribute("value") = "5" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Question")
                        End If
                    End If
                    If rbtnArrow.Checked = True Then
                        If Unit.GetAttribute("value") = "2" Then
                            Unit.InvokeMember("click")
                            AddLogInfo("Icon set! - Arrow")
                        End If
                    End If
                Next
            Catch ex As Exception
                MsgBox("CreateThread problem:" & ex.Message)
            End Try
        End If
    End Sub
    Public Sub CheckForumPostTime()
        If btnStop.Enabled = True Then
            'Checking Forum Post Time(time between available posts)
            Do Until ForumPostTime >= 31
                If ForumPostTime >= 31 Then Exit Do
                Application.DoEvents()
            Loop
        End If
    End Sub
    Public Sub PostThread()
        If btnStop.Enabled = True Then
            'Post the new thread
            For Each Unit As HtmlElement In wbForum.Document.All
                If Unit.GetAttribute("id") = "vB_Editor_001_save" Then
                    Unit.InvokeMember("click")
                    lblStatus.Text = "Loading Page"
                End If
            Next
        End If
    End Sub
    Public Sub WaitForPost()
        lblStatus.Text = "Loading Page"
        Do While lblStatus.Text = "Loading Page"
            If lblStatus.Text = "Page Loaded" Then Exit Do
            Application.DoEvents()
        Loop
    End Sub
    Public Sub PostFullMessage()
        If btnStop.Enabled = True Then
            NavigateBoard()
            NavigateMakeThread()
            CreateThread()
            CheckForumPostTime()
            PostThread()
            WaitForPost()
            ForumPostTime = 0
            AddLogInfo("--------------Posting procedure Nr: " & ProcedureNumber & " is done.--------------")
        End If
    End Sub
    Public Sub AddLogInfo(ByVal Info As String)
        txtPostingLog.Text = txtPostingLog.Text + vbNewLine + Info
    End Sub
    Private Sub tmrForumPostTime_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tmrForumPostTime.Tick
        ForumPostTime += 1
    End Sub
    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnExit.Click
        Environment.Exit(1)
    End Sub

    Private Sub btnDeleteLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnDeleteLink.Click
        lstForumBoardLinks.Items.Remove(lstForumBoardLinks.SelectedItem)
    End Sub

    Private Sub btnAddLink_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAddLink.Click
        If lstForumBoardLinks.Items.Contains(txtNewBoardLink.Text) Then
            MessageBox.Show("You already got that forum board in your link list!", "Already got it!", MessageBoxButtons.OK, MessageBoxIcon.Information)
        Else
            If Not txtNewBoardLink.Text = "" Then
                lstForumBoardLinks.Items.Add(txtNewBoardLink.Text)
            End If
        End If
    End Sub

    Private Sub txtPostBody_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles txtPostBody.TextChanged

    End Sub
End Class
